__author__ = 'fyt'

import socket
import random
import ClientBase
import copy as cp
import numpy as np
from operator import itemgetter
import pickle as pkl
import discard_ai as dai
import action_ai as aai
import os

class MyAgent(object):
    def __init__(self):
        self.CurrentHand  = []
        self.HandStrength = 0
        self.discard_ai   = dai.discard_ai()
        self.action_ai    = aai.action_ai()
        self.infoAgent    = None
        self.stack        = 0

Ranks = {
    '2': 1,
    '3': 2,
    '4': 3,
    '5': 4,
    '6': 5,
    '7': 6,
    '8': 7,
    '9': 8,
    'T': 9,
    'J': 10,
    'Q': 11,
    'K': 12,
    'A': 13
}

Suits = {
    'd': 1,
    'c': 2,
    'h': 3,
    's': 4
}

Types = {
    'HighCard':      1,
    'OnePair':       2,
    'TwoPairs':      3,
    '3OfAKind':      4,
    'Straight':      5,
    'Flush':         6,
    'FullHouse':     7,
    '4OfAKind':      8,
    'StraightFlush': 9
}



def get_hand_strength(type_rank, hand_rank):
    return type_rank * 13 + hand_rank

def identify_hand(Hand_):

    # Get the type of Hand
    def evaluateHand(Hand_):
        count = 0
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    count += 1
        return count

    # Use the "count" to analyse hand
    count_ = evaluateHand(Hand_)

    sub1 = 0
    score = [' ', ' ', ' ']

    if count_ == 12:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    sub1 += 1
            if sub1 == 3:
                score = ['4OfAKind', card1[0], card1[1]]
                break

    elif count_ == 8:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    sub1 += 1
            if sub1 == 1:
                sub1 = 0
            if sub1 == 2:
                score = ['FullHouse', card1[0], card1[1]]
                break

    elif count_ == 6:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    sub1 += 1
            if sub1 == 2:
                score = ['3OfAKind', card1[0], card1[1]]
                break

    elif count_ == 4:
        needCard1 = ['', '']
        needCard2 = ['', '']
        for card1 in Hand_:
            for card2 in Hand_:
                # card1 keep the first hand card, card1 use every card to compare the card1
                if card1[0] == card2[0] and card1[1] != card2[1]:
                    if Suits[card1[1]] > Suits[card2[1]]:
                        if needCard1 == ['', '']:
                            needCard1 = card1
                    else:
                        if needCard1 == ['', '']:
                            needCard1 = card2
                if card1[0] == card2[0] and card1[1] != card2[1] \
                        and card1[0] != needCard1[0] and card2[0] != needCard1[0]:
                    if Suits[card1[1]] > Suits[card2[1]]:
                        if needCard2 == ['', '']:
                            needCard2 = card1
                    else:
                        if needCard2 == ['', '']:
                            needCard2 = card2
        if Ranks[needCard1[0]] > Ranks[needCard2[0]]:
            score = ['TwoPairs', needCard1[0], needCard1[1]]
        else:
            score = ['TwoPairs', needCard2[0], needCard2[1]]

    elif count_ == 2:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] > card2[1]):
                    sub1 += 1
            if sub1 == 1:
                score = ['OnePair', card1[0], card1[1]]
                break

    elif count_ == 0:
        def sortHand(Hand_):
            hand_sorted_ = sorted([[card_, Ranks[card_[0]]] for card_ in Hand_], key=itemgetter(1))[:]
            return [card_[0] for card_ in hand_sorted_]

        Hand_ = sortHand(Hand_)
        score = ['HighCard', Hand_[4][0], Hand_[4][1]]

        if Hand_[0][1] == Hand_[1][1] == Hand_[2][1] == Hand_[3][1] == Hand_[4][1]:
            score = ['Flush', Hand_[4][0], Hand_[4][1]]

        if (Ranks[Hand_[4][0]] - Ranks[Hand_[3][0]] == 1) \
                and (Ranks[Hand_[3][0]] - Ranks[Hand_[2][0]] == 1) \
                and (Ranks[Hand_[2][0]] - Ranks[Hand_[1][0]] == 1) \
                and (Ranks[Hand_[1][0]] - Ranks[Hand_[0][0]] == 1):
            score = ['Straight', Hand_[4][0], Hand_[4][1]]

            if Hand_[0][1] == Hand_[1][1] == Hand_[2][1] == Hand_[3][1] == Hand_[4][1]:
                score = ['StraightFlush', Hand_[4][0], Hand_[4][1]]
    else:
        exit(5664)
    return score

# IP address and port
TCP_IP = '127.0.0.1'
TCP_PORT = 5000
BUFFER_SIZE = 1024

# Agent
#POKER_CLIENT_NAME = os.path.basename(os.getcwd())
POKER_CLIENT_NAME = "LASERBEAM"
CURRENT_HAND = []
SAVE_DATA = False

class pokerGames(object):
    def __init__(self):
        self.PlayerName = POKER_CLIENT_NAME
        self.Chips = 0
        self.CurrentHand = []
        self.Ante = 0
        self.playersCurrentBet = 0
        Dagent.infoAgent = self

'''
* Gets the name of the player.
* @return  The name of the player as a single word without space. <code>null</code> is not a valid answer.
'''
def queryPlayerName(_name):
    if _name is None:
        _name = POKER_CLIENT_NAME
    return _name

'''
* Modify queryOpenAction() and add your strategy here
* Called during the betting phases of the game when the player needs to decide what open
* action to choose.
* @param minimumPotAfterOpen   the total minimum amount of chips to put into the pot if the answer action is
*                              {@link BettingAnswer#ACTION_OPEN}.
* @param playersCurrentBet     the amount of chips the player has already put into the pot (dure to the forced bet).
* @param playersRemainingChips the number of chips the player has not yet put into the pot.
* @return                      An answer to the open query. The answer action must be one of
*                              {@link BettingAnswer#ACTION_OPEN}, {@link BettingAnswer#ACTION_ALLIN} or
*                              {@link BettingAnswer#ACTION_CHECK }. If the action is open, the answers
*                              amount of chips in the anser must be between <code>minimumPotAfterOpen</code>
*                              and the players total amount of chips (the amount of chips alrady put into
*                              pot plus the remaining amount of chips).
'''
def queryOpenAction(_minimumPotAfterOpen, _playersCurrentBet, _playersRemainingChips):
    # Random Open Action
    global cool_stack_p
    global bet_list
    global final_pot
    global bet_dict
    action, amount = Dagent.action_ai.predict_open(cool_stack_p, Dagent.HandStrength, _playersCurrentBet, final_pot, _minimumPotAfterOpen, _playersRemainingChips, bet_dict)
    move = np.argmax(action)

    if Dagent.HandStrength >= 38:
        return ClientBase.BettingAnswer.ACTION_ALLIN
    """
    print "***** PREDICTED OPEN *****"
    print "MOVE:",move
    print "ACTIONS:",action,"AMOUNT:",amount
    print "0=OPEN, 1=ALLIN, 2=CHECK"
    print "*****  PREDICTED OPEN *****"
    """

    if move == 0:
        return ClientBase.BettingAnswer.ACTION_OPEN, amount
    if move == 1:
        return ClientBase.BettingAnswer.ACTION_ALLIN
    else:
        return ClientBase.BettingAnswer.ACTION_CHECK

'''
* Modify queryCallRaiseAction() and add your strategy here
* Called during the betting phases of the game when the player needs to decide what call/raise
* action to choose.
* @param maximumBet                the maximum number of chips one player has already put into the pot.
* @param minimumAmountToRaiseTo    the minimum amount of chips to bet if the returned answer is {@link BettingAnswer#ACTION_RAISE}.
* @param playersCurrentBet         the number of chips the player has already put into the pot.
* @param playersRemainingChips     the number of chips the player has not yet put into the pot.
* @return                          An answer to the call or raise query. The answer action must be one of
*                                  {@link BettingAnswer#ACTION_FOLD}, {@link BettingAnswer#ACTION_CALL},
*                                  {@link BettingAnswer#ACTION_RAISE} or {@link BettingAnswer#ACTION_ALLIN }.
*                                  If the players number of remaining chips is less than the maximum bet and
*                                  the players current bet, the call action is not available. If the players
*                                  number of remaining chips plus the players current bet is less than the minimum
*                                  amount of chips to raise to, the raise action is not available. If the action
*                                  is raise, the answers amount of chips is the total amount of chips the player
*                                  puts into the pot and must be between <code>minimumAmountToRaiseTo</code> and
*                                  <code>playersCurrentBet+playersRemainingChips</code>.
'''
def queryCallRaiseAction(_maximumBet, _minimumAmountToRaiseTo, _playersCurrentBet, _playersRemainingChips):
    global cool_stack_p
    global bet_list
    global final_pot
    global bet_dict
    action, raiseAmount = Dagent.action_ai.predict_raise(cool_stack_p, Dagent.HandStrength, _playersCurrentBet,final_pot,_minimumAmountToRaiseTo,_maximumBet,_playersRemainingChips,bet_dict)
    """
    print "##"*10
    print "PREDTICTION"
    print action
    raiseAmount += _playersCurrentBet
    print "raise amount: ",raiseAmount
    print len(action)
    print "##"*10
    """

    if Dagent.HandStrength >= 38:
        return ClientBase.BettingAnswer.ACTION_ALLIN

    move = np.argmax(action)
    #print action

    if len(action) == 4:
        #print "PREDICTED MOVE:",move,"(0=RAISE, 1=ALLIN, 2=CALL, 3=FOLD)"
        if move == 0:
            """
            print "RAISE:",raiseAmount
            print "CURRENTBET:",_playersCurrentBet
            print "REMANING:",_playersRemainingChips
            print "STACK:",cool_stack_p,"(",Dagent.infoAgent.Chips,")"
            print "MAX:",_maximumBet,"MIN:",_minimumAmountToRaiseTo,"IGUESS:",(_minimumAmountToRaiseTo-_maximumBet)
            """
            if raiseAmount+_minimumAmountToRaiseTo <= cool_stack_p:
                return ClientBase.BettingAnswer.ACTION_RAISE, (raiseAmount+_playersCurrentBet)
            else:
                """
                print "*****************"
                print "FORCED TO FOLD!"
                print "Stack:",cool_stack_p
                print "Raise:",raiseAmount,"bid:",_playersCurrentBet
                print "MINIUMUM:",_minimumAmountToRaiseTo
                print "MAX",_maximumBet
                print "*****************"
                """

                return ClientBase.BettingAnswer.ACTION_FOLD
        if move == 1:
            return ClientBase.BettingAnswer.ACTION_ALLIN
        if move == 2:
            return ClientBase.BettingAnswer.ACTION_CALL if _playersCurrentBet + _playersRemainingChips >= _maximumBet else ClientBase.BettingAnswer.ACTION_FOLD
        if move == 3:
            return ClientBase.BettingAnswer.ACTION_FOLD
    else:
        #print "PREDICTED MOVE:",move,"(0=ALLIN, 1=CALL, 2=FOLD)"
        if move == 0:
            return ClientBase.BettingAnswer.ACTION_ALLIN
        if move == 1:
            return ClientBase.BettingAnswer.ACTION_CALL if _playersCurrentBet + _playersRemainingChips >= _maximumBet else ClientBase.BettingAnswer.ACTION_FOLD
        if move == 2:
            return ClientBase.BettingAnswer.ACTION_FOLD

'''
===========================================
'''

target_data = []
input_data = []

features = []

feature = [0, 0, 0, 0, 0, 0, 0, 0]
bet_list = []
feature_list = []

current_hand = None
current_pot = 0

current_opponent_stack = 0

call_cost = 10

cool_stack_p = 0
cool_stack_o = 0

round_counter = 0
first_stack_call = True
first_round_call = True
strat_flag = True
did_laser_beam_win_flag = False
stack = 0

untouched_stack = 200

feature_count = 0
label_count = 0
chip_info_counter = 0

round_tracker = 0

opponent_dict = {}
bet_dict = {}
bets = []
final_pot = 0

Dagent = MyAgent()

event_list = []

action_dict = {'forced':[1,0,0,0,0,0,0],
               'open':  [0,1,0,0,0,0,0],
               'raise': [0,0,1,0,0,0,0],
               'allin': [0,0,0,1,0,0,0],
               'check': [0,0,0,0,1,0,0],
               'call':  [0,0,0,0,0,1,0],
               'fold':  [0,0,0,0,0,0,1]
               }

def add_feature(info):
    global feature
    global label
    input = cp.deepcopy(info)
    feature_list.append(input)
    feature = [0, 0, 0, 0, 0, 0, 0, 0]



'''
===========================================
'''




'''
* Modify queryCardsToThrow() and add your strategy to throw cards
* Called during the draw phase of the game when the player is offered to throw away some
* (possibly all) of the cards on hand in exchange for new.
* @return  An array of the cards on hand that should be thrown away in exchange for new,
*          or <code>null</code> or an empty array to keep all cards.
* @see     #infoCardsInHand(ca.ualberta.cs.poker.Hand)
'''
def queryCardsToThrow(_hand):
    event_list.append('THROW')
    print("Requested information about what cards to throw")
    print "*" * 15
    print "*" * 15
    temp_hand = ''
    Dagent.CurrentHand = dai.card_sorter(_hand)
    print("QUERY THROW CARD", Dagent.CurrentHand)
    predict_return = Dagent.discard_ai.predict(Dagent.CurrentHand)
    action = np.argmax(predict_return)
    print "RECIEVED: ", action, "which is:", dai.ChangeAction[action]
    print predict_return

    actions_ = []
    for v in range(0, len(predict_return)):
        if abs(predict_return[v] - predict_return[action]) <= 0.5:
            actions_.append(v)
            print "Addade: ", v, "- DIFF:", abs(predict_return[v] - predict_return[action])
    if len(actions_) > 1:
        cv = actions_[random.randint(0, len(actions_)-1)]
    else:
        cv = action

    print "-" * 15
    if cv > 0:
        for c in range(1, cv+1):
            temp_hand += Dagent.CurrentHand[c] + ' '
        print "CHANING:", temp_hand
    else:
        print "NO CHANGES!!"
    print "*" * 15
    print "*" * 15
    return temp_hand

# InfoFunction:

'''
* Called when a new round begins.
* @param round the round number (increased for each new round).
'''


def infoNewRound(_round):
    event_list.append('NEWROUND')
    global round_tracker
    global first_round_call
    global target_data
    global input_data
    global feature_list
    global bet_list
    global cool_stack_p
    global cool_stack_o
    global bet_dict
    global final_pot
    global call_cost

    round_tracker = _round
    bet_dict.clear()
    call_cost = 10
    cool_stack_o = cool_stack_p
    cool_stack_p = Dagent.infoAgent.Chips

    if Dagent.infoAgent.Chips == 0:
        #print "PROBABLY ERRORR and first round"
        cool_stack_p = 200
        cool_stack_o = cool_stack_p
        print cool_stack_o,cool_stack_p


    if first_round_call:
        bet_list = []
        feature_list = []
        final_pot = 0
        exists = os.path.isfile(POKER_CLIENT_NAME + "y_train.pkl")
        if exists and SAVE_DATA == True:
            #print "It exists"
            target_data = pkl.load(open(POKER_CLIENT_NAME + "y_train.pkl", "rb"))
            input_data = pkl.load(open(POKER_CLIENT_NAME + "x_train.pkl", "rb"))
        else:
            print "File doesnt exists"
        first_round_call = False
    else:
        bet_list = []
        feature_list = []
        final_pot = 0

    print('Starting Round: ' + _round)


'''
* Called when the poker server informs that the game is completed.
'''


def infoGameOver():
    global feature_count
    global label_count
    global current_pot
    global feature_list
    global bet_list
    global cool_stack_p
    global cool_stack_o
    global final_pot

    bet_list = []
    feature_list = []
    final_pot = 0

    #print "FEATURE:", input_data, "TARGET: ", target_data
    if SAVE_DATA == True:
        pkl.dump(input_data, open(POKER_CLIENT_NAME + "x_train.pkl", "wb" ))
        pkl.dump(target_data, open(POKER_CLIENT_NAME + "y_train.pkl", "wb"))
        print "SAVED DATA"

    print('The game is over.')
    print event_list


'''
* Called when the server informs the players how many chips a player has.
* @param playerName    the name of a player.
* @param chips         the amount of chips the player has.
'''


def infoPlayerChips(_playerName, _chips):
    global opponent_dict
    global cool_stack_p
    global cool_stack_o

    cool_stack_p = Dagent.infoAgent.Chips
    cool_stack_o = Dagent.infoAgent.Chips

    if Dagent.infoAgent.Chips == 0:
        cool_stack_p = 200
        cool_stack_o = 200

    print _playerName,"has",_chips,"and",POKER_CLIENT_NAME,"has",Dagent.infoAgent.Chips,cool_stack_p

    if _playerName != POKER_CLIENT_NAME:
        opponent_dict[_playerName] = int(_chips)



'''
* Called when the ante has changed.
* @param ante  the new value of the ante.
'''


def infoAnteChanged(_ante):
    print "Ante time"


def create_feature(playerstack, current_h_str, amount, currentpot, move):
    global feature
    global cool_stack_p
    global current_pot
    feature[0] = playerstack
    feature[1] = current_h_str
    feature[2] = amount
    feature[3] = currentpot
    #8-14
    finished_feature = feature + action_dict[move]
    print "FEATURE:", finished_feature
    add_feature(finished_feature)



'''
* Called when a player had to do a forced bet (putting the ante in the pot).
* @param playerName    the name of the player forced to do the bet.
* @param forcedBet     the number of chips forced to bet.
'''

def infoForcedBet(_playerName, _forcedBet):
    global feature
    global bet_list
    global current_pot
    global cool_stack_p
    global bet_dict
    global final_pot

    bet_dict[_playerName] = int(_forcedBet)
    bet_dict[POKER_CLIENT_NAME] = int(_forcedBet)

    pot = 0
    o_b = bet_dict.keys()
    for p_name in o_b:
        pot += int(bet_dict[p_name])

    final_pot = pot



'''
* Called when a player opens a betting round.
* @param playerName        the name of the player that opens.
* @param openBet           the amount of chips the player has put into the pot.
'''


def infoPlayerOpen(_playerName, _openBet):
    global feature
    global bet_list
    global current_pot
    global cool_stack_p
    global cool_stack_o
    global bet_dict
    global final_pot

    if _playerName in bet_dict:
        last_bet = bet_dict[_playerName]
    else:
        last_bet = 0

    bet_dict[_playerName] = int(_openBet)

    pot = 0
    o_b = bet_dict.keys()
    for p_name in o_b:
        pot += int(bet_dict[p_name])

    final_pot = pot
    call_cost = int(_openBet)

    if _playerName == POKER_CLIENT_NAME:
        bets.append((int(_openBet) - last_bet))
        bet_list.append(int(_openBet))
        print "============================================================================"
        print "CURRENT ROUND: ", round_tracker
        print "STACK BEFORE: ", cool_stack_p
        cool_stack_p -= (int(_openBet) - last_bet)
        #cool_stack_o = cool_stack_p - int(_openBet)
        create_feature(cool_stack_p, Dagent.HandStrength, int(_openBet), pot, 'open')

        print "OPEN: ", _playerName, ":", _openBet
        print "STACK AFTER: ", cool_stack_p
        print "============================================================================"


'''
* Called when a player raises.
* @param playerName        the name of the player that raises.
* @param amountRaisedTo    the amount of chips the player raised to.
'''


def infoPlayerRise(_playerName, _amountRaisedTo):
    event_list.append('RAISE' + _playerName)
    global feature
    global bet_list
    global current_pot
    global call_cost
    global cool_stack_p
    global cool_stack_o
    global bet_dict
    global final_pot

    if _playerName in bet_dict:
        last_bet = bet_dict[_playerName]
    else:
        last_bet = 0

    bet_dict[_playerName] = int(_amountRaisedTo)

    pot = 0
    o_b = bet_dict.keys()
    for p_name in o_b:
        pot += int(bet_dict[p_name])
    call_cost = int(_amountRaisedTo)
    final_pot = pot

    if _playerName == POKER_CLIENT_NAME:
        bet_list.append(int(_amountRaisedTo)-last_bet)
        print "============================================================================"
        print "CURRENT ROUND: ", round_tracker
        print "STACK BEFORE: ", cool_stack_p
        cool_stack_p -= (int(_amountRaisedTo)-last_bet)
        #cool_stack_o = cool_stack_p - int(_amountRaisedTo)
        create_feature(cool_stack_p, Dagent.HandStrength, int(_amountRaisedTo), pot, 'raise')
        print "RAISE: ", _playerName, ":", _amountRaisedTo
        print "STACK AFTER: ", cool_stack_p
        print "============================================================================"


'''
* Called when a player goes all-in.
* @param playerName        the name of the player that goes all-in.
* @param allInChipCount    the amount of chips the player has in the pot and goes all-in with.
'''


def infoPlayerAllIn(_playerName, _allInChipCount):
    event_list.append('ALLIN' + _playerName)
    global feature
    global bet_list
    global current_pot
    global cool_stack_p
    global cool_stack_o
    global call_cost
    global bet_dict
    global final_pot

    if _playerName in bet_dict:
        last_bet = bet_dict[_playerName]
    else:
        last_bet = 0

    bet_dict[_playerName] = int(_allInChipCount)

    pot = 0
    o_b = bet_dict.keys()
    for p_name in o_b:
        pot += int(bet_dict[p_name])
    call_cost = int(_allInChipCount)
    final_pot = pot

    if _playerName == POKER_CLIENT_NAME:
        bet_list.append(int(_allInChipCount) - last_bet)
        print "============================================================================"
        print "CURRENT ROUND: ", round_tracker
        print "STACK BEFORE: ", cool_stack_p
        cool_stack_p = 0
        #cool_stack_o = cool_stack_p - int(_allInChipCount)
        create_feature(cool_stack_p, Dagent.HandStrength, int(_allInChipCount), pot, 'allin')
        print "ALLIN: ", _playerName, ":", _allInChipCount
        print "STACK AFTER: ", cool_stack_p
        print "============================================================================"


'''
* Called when a player checks.
* @param playerName        the name of the player that checks.
'''


def infoPlayerCheck(_playerName):
    global feature
    global bet_list
    global current_pot
    global cool_stack_p
    global cool_stack_o
    global bet_dict
    global final_pot

    if _playerName in bet_dict:
        last_bet = bet_dict[_playerName]
    else:
        last_bet = 0

    bet_dict[_playerName] = int(call_cost)

    pot = 0
    o_b = bet_dict.keys()
    for p_name in o_b:
        pot += int(bet_dict[p_name])
    final_pot = pot

    if _playerName == POKER_CLIENT_NAME:
        print "============================================================================"
        print "CURRENT ROUND: ", round_tracker
        print "STACK BEFORE: ", cool_stack_p
        #cool_stack_o = cool_stack_p - call_cost
        cool_stack_p -= int(call_cost)-last_bet
        create_feature(cool_stack_p, Dagent.HandStrength, int(call_cost)-last_bet, pot, 'check')
        bet_list.append(int(call_cost)-last_bet)
        print "CHECK: ", _playerName, ":", call_cost-last_bet
        print "STACK AFTER: ", cool_stack_p
        print "============================================================================"


'''
* Called when a player calls.
* @param playerName        the name of the player that calls.
'''


def infoPlayerCall(_playerName):
    global feature
    global bet_list
    global call_cost
    global cool_stack_p
    global cool_stack_o
    global bet_dict
    global final_pot


    if _playerName in bet_dict:
        last_bet = bet_dict[_playerName]
    else:
        last_bet = 0

    bet_dict[_playerName] = int(call_cost)

    pot = 0
    o_b = bet_dict.keys()
    for p_name in o_b:
        pot += int(bet_dict[p_name])
    final_pot = pot

    if _playerName == POKER_CLIENT_NAME:
        print "============================================================================"
        print "CURRENT ROUND: ", round_tracker
        print "STACK BEFORE: ", cool_stack_p
        bet_list.append(int(call_cost)-last_bet)
        cool_stack_p -= int(call_cost)-last_bet
        create_feature(cool_stack_p, Dagent.HandStrength, int(call_cost)-last_bet, pot, 'call')
        print "CALL: ", _playerName, ":", call_cost
        print "STACK AFTER: ", cool_stack_p
        print "============================================================================"


'''
* Called when a player folds.
* @param playerName        the name of the player that folds.
'''


def infoPlayerFold(_playerName):
    global feature
    global bet_list
    global current_pot
    global cool_stack_o
    global cool_stack_p

    if _playerName == POKER_CLIENT_NAME:
        print "============================================================================"
        print "CURRENT ROUND: ", round_tracker
        print "STACK BEFORE: ", cool_stack_p
        create_feature(cool_stack_p, Dagent.HandStrength, 0, final_pot, 'fold')
        bet_list.append(0)
        print "FOLD: ", _playerName, ":", 0
        print "STACK AFTER: ", cool_stack_p
        print "============================================================================"


'''
* Called when a player has exchanged (thrown away and drawn new) cards.
* @param playerName        the name of the player that has exchanged cards.
* @param cardCount         the number of cards exchanged.
'''


def infoPlayerDraw(_playerName, _cardCount):
    print "DRAW"


'''
* Called during the not showdown when a player shows his hand.
* @param playerName        the name of the player whose hand is shown.
* @param hand              the players hand.
'''


def infoPlayerHand(_playerName, _hand):
    global cool_stack_p
    global cool_stack_o

    cool_stack_p = Dagent.infoAgent.Chips
    cool_stack_o = Dagent.infoAgent.Chips

    if Dagent.infoAgent.Chips == 0:
        cool_stack_p = 200
        cool_stack_o = 200

    if _playerName == POKER_CLIENT_NAME:
        CURRENT_HAND.append(_hand)
        Dagent.CurrentHand = dai.card_sorter(_hand)
        Dagent.HandStrength = dai.evaluate_hand(Dagent.CurrentHand)
        print "CURRENT HAND: ",Dagent.CurrentHand,"HAND STRENGTH",Dagent.HandStrength


'''
* Called during the showdown when a players undisputed win is reported.
* @param playerName    the name of the player whose undisputed win is announced.
* @param winAmount     the amount of chips the player won.
'''


def infoRoundUndisputedWin(_playerName, _winAmount):
    global current_pot
    global cool_stack_p
    global cool_stack_o

    current_pot = 0
    if _playerName == POKER_CLIENT_NAME:
        did_laser_beam_win_flag = True
    else:
        did_laser_beam_win_flag = False

    print("Player " + _playerName + " won " + _winAmount + " chips undisputed.")


'''
* Called during the showdown when a players win is reported. If a player does not win anything,
* this method is not called.
* @param playerName    the name of the player whose win is announced.
* @param winAmount     the amount of chips the player won.
'''


def infoRoundResult(_playerName, _winAmount):
    global current_pot
    global cool_stack_p
    global cool_stack_o
    global did_laser_beam_win_flag

    current_pot = 0
    if _playerName == POKER_CLIENT_NAME:
        did_laser_beam_win_flag = True
    else:
        did_laser_beam_win_flag = False


    print("Player " + _playerName + " won " + _winAmount + " chips.")
