import os
import random
import numpy as np
import copy
from sklearn.ensemble import GradientBoostingRegressor
from sklearn.metrics import mean_squared_error
from matplotlib import pyplot
import pickle as pkl

ACTION_DATA = '../data/LASERBEAM_REGRESSOR_V2.pkl'

action_dict_raise = {
                0:  [0,0,1,0,0,0,0], #raise
                1:  [0,0,0,1,0,0,0], #allin
                2:  [0,0,0,0,0,1,0], #call
                3:  [0,0,0,0,0,0,1]  #fold
               }
action_dict_open = {
                0:  [0,1,0,0,0,0,0], #open
                1:  [0,0,0,1,0,0,0], #allin
                2:  [0,0,0,0,1,0,0]  #check
}

"""
action_dict = {'forced':[1,0,0,0,0,0,0],
               'open':  [0,1,0,0,0,0,0],
               'raise': [0,0,1,0,0,0,0],
               'allin': [0,0,0,1,0,0,0],
               'check': [0,0,0,0,1,0,0],
               'call':  [0,0,0,0,0,1,0],
               'fold':  [0,0,0,0,0,0,1]
"""

#"stk", "str", "bet", "pot",

class action_ai(object):
    def __init__(self, data=ACTION_DATA):
        self.model = pkl.load(open(ACTION_DATA, "rb"))
        if self.model == None:
            print "ERROR WITH LOADING DATA"

    # queryCallRaiseAction
    def predict_raise(self, _mystack, _mystr, _mybid, _pot, _minimumAmountToRaiseTo, _maximumBet,_playersRemainingChips, players_list):
        feature = [0, 0, 0, 0, 0, 0, 0, 0]
        allFeatures = []

        raiseIndex = 0
        raiseFeature = [0, 0, 0, 0, 0, 0, 0, 0]
        raiseAmount = 0
        raisePrediction = -999
        f_index = 4
        opponents_bets = 0
        for _pn in players_list:
            if _pn != os.path.basename(os.getcwd()) and f_index <= 7:
                feature[f_index] = players_list[_pn]
                f_index += 1
                opponents_bets += players_list[_pn]

        for a_ in range(0,4):
            if a_ == 0: #RAISE
                add_raise = False
                min = _maximumBet-_mybid
                # CURRENTBET - MINBET?

                print "RAISE"
                print "MY BID:", _mybid
                print "MY STK TOTAL:", _mystack,"WITH BID:", _mystack-_mybid
                print "MIN:", _minimumAmountToRaiseTo, "MAX:", _maximumBet,
                print "I GUESS LOWEST BID:",min
                print "POT:", _pot,"OPPONENTS BETS:", opponents_bets,"MY BET:",(int(_pot)-int(opponents_bets))
                testing = _mystack-_minimumAmountToRaiseTo

                if _mystack >= _minimumAmountToRaiseTo:

                    for i in range(1,4):
                        if testing > 0:
                            tmpraiseAmount = random.randint(1, testing)+_minimumAmountToRaiseTo
                        else:
                            tmpraiseAmount = random.randint(1, 10)+_minimumAmountToRaiseTo

                        if _mystack - _playersRemainingChips >= 0:
                            feature[0] = _mystack
                            feature[1] = _mystr
                            feature[2] = tmpraiseAmount+_mybid
                            feature[3] = _pot+tmpraiseAmount

                            tmp = self.model.predict([feature+action_dict_raise[a_]])
                            print "-----"*4
                            print "TESTING RAISE:",feature,tmp
                            print "mystack",_mystack," tmpraise:",tmpraiseAmount
                            print "tmp:",tmp," riasePredic:",raisePrediction
                            print "----"*4

                            if tmp > raisePrediction:
                                for i in range(0,4):
                                    raiseFeature[i] = feature[i]
                                raiseAmount = tmpraiseAmount
                                raisePrediction = tmp
                                add_raise = True

                    if add_raise == True:
                        feature = copy.deepcopy(raiseFeature)
                        f_index = 4
                        for _pn in players_list:
                            if _pn != os.path.basename(os.getcwd()) and f_index <= 7:
                                feature[f_index] = players_list[_pn]
                                f_index += 1
                        allFeatures.append(feature+action_dict_raise[a_])

            if a_ == 1: #ALL IN
                print "ALL IN"
                feature[0] = _mystack
                feature[1] = _mystr
                feature[2] = _mybid+_mystack
                feature[3] = _pot
                f_index = 4
                for _pn in players_list:
                    if _pn != os.path.basename(os.getcwd()) and f_index <= 7:
                        feature[f_index] = players_list[_pn]
                        f_index += 1
                allFeatures.append(feature+action_dict_raise[a_])

            if a_ == 2: #CALL
                print "CALL"
                feature[0] = _mystack
                feature[1] = _mystr
                feature[2] = _mybid+_minimumAmountToRaiseTo
                feature[3] = _pot+_mybid+_minimumAmountToRaiseTo
                f_index = 4
                for _pn in players_list:
                    if _pn != os.path.basename(os.getcwd()) and f_index <= 7:
                        feature[f_index] = players_list[_pn]
                        f_index += 1
                allFeatures.append(feature+action_dict_raise[a_])

            if a_ == 3: #FOLD
                print "FOLD"
                feature[0] = _mystack-_pot
                feature[1] = _mystr
                feature[2] = _mybid
                feature[3] = _pot+_mybid
                f_index = 4
                for _pn in players_list:
                    if _pn != os.path.basename(os.getcwd()) and f_index <= 7:
                        feature[f_index] = players_list[_pn]
                        f_index += 1
                allFeatures.append(feature+action_dict_raise[a_])


        pReturn = self.model.predict(allFeatures)
        return pReturn, raiseAmount


    """
                    0:  [0,1,0,0,0,0,0], #open
                    1:  [0,0,0,1,0,0,0], #allin
                    2:  [0,0,0,0,1,0,0]  #check
    """

    def predict_open(self, _mystack, _mystr, _mybid, _pot, _minimumPotAfterOpen, _playersRemainingChips, players_list):
        feature = [0, 0, 0, 0, 0, 0, 0, 0]
        allFeatures = []
        f_index = 4
        opponents_bets = 0
        openAmount = 0

        for _pn in players_list:
            if _pn != os.path.basename(os.getcwd()) and f_index <= 7:
                feature[f_index] = players_list[_pn]
                f_index += 1
                opponents_bets += players_list[_pn]

        print "#" * 20
        print "Predicted open stats"
        print "my stack:",_mystack,"my bid:",_mybid
        print "minium pot after open:",_minimumPotAfterOpen
        print "min open bid:",_minimumPotAfterOpen-_mybid
        print "remaning chips",_playersRemainingChips
        print "pot:",_pot,"opponents bets:",opponents_bets
        print "#" * 20

        min_bid = _minimumPotAfterOpen-_mybid

        for a_ in range(0,3):
            if a_ == 0: #open
                openAmount = random.randint(0, 20) + _minimumPotAfterOpen
                if openAmount > _mystack:
                    openAmount = min_bid
                feature[0] = _mystack+openAmount
                feature[1] = _mystr
                feature[2] = openAmount
                feature[3] = _pot+openAmount
            if a_ == 1: #ALL IN
                feature[0] = _pot+_mybid+_mystack+openAmount
                feature[1] = _mystr
                feature[2] = _mybid+_mystack
                feature[3] = _pot+_mybid+_mystack+openAmount
            if a_ == 2: # check
                feature[0] = _mystack-min_bid
                feature[1] = _mystr
                feature[2] = _mybid+min_bid
                feature[3] = _pot+min_bid

            allFeatures.append(feature+action_dict_raise[a_])
        pReturn = self.model.predict(allFeatures)
        return pReturn, openAmount
